import fs from 'fs';
import path from 'path';

export const readDir = (dir: string, fn?: (filename: string) => void): string[] => {
  let arr: string[] = [];
  if (!fs.existsSync(dir)) return arr;

  fs.readdirSync(dir).map(d => {
    const filename = path.resolve(dir, d);
    const stat = fs.statSync(filename);

    if (stat.isFile()) {
      fn && fn(filename);
      arr.push(filename);
    } else {
      arr = arr.concat(readDir(filename, fn));
    }
  });

  return arr;
};
